/*
   DEONotification.m created by enoyau on Fri 13-Jan-1995

   You may freely copy, distribute, and reuse the code in this example.
   NeXT disclaims any warranty of any kind, expressed or implied, as to its
   fitness for any particular use.
*/

#import "DEONotification.h"

@implementation DEONotification

- initWithName:(NSString *)notificationName
        object:notificationObject
      userInfo:(NSDictionary *)notificationUserInfo
       isLocal:(BOOL)yn
{
    name = [notificationName copy];
    object = [notificationObject retain];
    userInfo = [notificationUserInfo copy];
    isLocal = yn;
    return self;
}

+ (DEONotification *)notificationWithName:(NSString *)notificationName
                                   object:notificationObject
                                 userInfo:(NSDictionary *)notificationUserInfo
                                  isLocal:(BOOL)yn
{
    return [[self alloc] initWithName:notificationName
                               object:notificationObject
                             userInfo:notificationUserInfo
                              isLocal:yn];
}

- (void)dealloc {
    [name release];
    [object release];
    [userInfo release];
    [super dealloc];
}

- (NSString *)notificationName { return name; }
- notificationObject           { return object;}
- (NSDictionary *)userInfo     { return userInfo; }
- (BOOL)isLocal                { return isLocal; }

@end
