/*
   DEONotificationCenter.h created by enoyau on Fri 13-Jan-1995

   You may freely copy, distribute, and reuse the code in this example.
   NeXT disclaims any warranty of any kind, expressed or implied, as to its
   fitness for any particular use.
*/
// DEONotificationCenter is working like an NSNotificationCenter. However,
// objects used in the API are enterprise objects only. Each
// DEONotificationCenter corresponds to an entity, and encodes the enterprise
// objects belonging to that entity over the wire.

#import <eoaccess/eoaccess.h>

// Notification names for EO operations
extern NSString *DEOUpdate;
extern NSString *DEOInsert;
extern NSString *DEODelete;

@class DEOServerMonitor;

@interface DEONotificationCenter : NSObject
{
    EOEntity *entity;
    EODatabaseChannel *databaseChannel;
    NSNotificationCenter *localCenter;
    DEOServerMonitor *monitor;
    NSDictionary *localID;
    id container;
}

+ (NSString *)localHostname;

- initWithDatabaseChannel:(EODatabaseChannel *)aDatabaseChannel
                   entity:(EOEntity *)anEntity;

- (void)addObserver:observer
           selector:(SEL)selector
   notificationName:(NSString *)notificationName
             object:object;

- (void)removeObserver:observer
      notificationName:(NSString *)notificationName
                object:object;

- (void)removeObserver:observer;

- (void)postNotificationName:(NSString *)name object:object;
- (void)postNotificationName:(NSString *)name
                      object:object
                    userInfo:(NSDictionary *)userInfo;
@end
