/*
   FoundationExtensions.m modified by enoyau on Fri 13-Jan-1995

   You may freely copy, distribute, and reuse the code in this example.
   NeXT disclaims any warranty of any kind, expressed or implied, as to its
   fitness for any particular use.
*/
/*
 *  Categories on NSArray and NSDictionary that allow them to be
 *  sent over the wire like a regular object.  Currently only NSString,
 *  NSData and NSNumber implement the NXTransport protocol so only those
 *  classes can be sent by value over the wire.
 *
 *  No guarantee is made for the fitness of this code for any particular
 *  use.  No warranty expressed or implied.  Use at your own risk!
 *
 *  Randy Tidd
 *  NeXT Premium Developer Support
 */
#import "FoundationExtensions.h"
#import "FoundationExtensionsPrivate.h"

@implementation NSArray (DOExtensions)
- encodeRemotelyFor:connection freeAfterEncoding:(BOOL *)flag isBycopy:(BOOL)isBycopy
{
    *flag = YES;
    return [[_NSArrayPlaceHolder alloc] initWithArray:self];
}
@end

@implementation NSDictionary (DOExtensions)
- encodeRemotelyFor:connection freeAfterEncoding:(BOOL *)flag isBycopy:(BOOL)isBycopy
{
    *flag = YES;
    return [[_NSDictionaryPlaceHolder alloc] initWithDictionary:self];
}
@end
