/* ResetRelationships.h created by cfeder on Thu 15-Dec-1994 */
#import <eoaccess/eoaccess.h>

// These extensions helps handle resetting relationship pointers when foreign
// key attributes in the source object have changed.  Most programs
// would be better off going the other direction: set the relationship pointer
// to the new destination object, and then use the methods above to fix
// up the keys.  RelationshipKeySetter handles this case.
@interface EODatabaseChannel (setForeignKey)
- objectForPrimaryKey:(NSDictionary *)key entity:(EOEntity *)entity;
- fetchObjectDescribedByQualifier:(EOQualifier *)qualifier;
- destinationObjectForRelationship:relationship sourceObject:sourceObject;
- (void)updateRelationshipsInObject:object forModifiedAttributes:(NSArray *)attributes;
@end


