/*--------------------------------------------------------------------------
 *
 * 	You may freely copy, distribute, and reuse the code in this example.
 * 	SHL Systemhouse disclaims any warranty of any kind, expressed or  
 *	implied, as to its fitness for any particular use.
 *
 *	Author
 *
 *	Inherits From:		NSObject
 *
 *	Conforms To:		None
 *
 *	Declared In:		Author.h
 *
 *------------------------------------------------------------------------*/
#import "Author.h"
#import "Address.h"
#import <foundation/NSString.h>




@implementation Author

/*--------------------------------------------------------------------------
 *	Init and Dealloc
 *------------------------------------------------------------------------*/
- init
{
	[super init];
	address = [[Address allocWithZone: [self zone]] init];
	return self;
}


- (void) dealloc
{
 	[au_id autorelease];
	[fullname autorelease];
	[address autorelease];
	[super dealloc];
}


/*--------------------------------------------------------------------------
 *	Accessors
 *------------------------------------------------------------------------*/
- (NSString *) fullname
{
	return fullname;
}


- (NSString *) address
{
	return [address address];
}


- (NSString *) city
{
	return [address city];
}


- (NSString *) state
{
	return [address state];
}


- (NSString *) zip
{
	return [address zip];
}


- (void) setFullname: (NSString *)aName
{
	[fullname autorelease];
	fullname = [aName retain];
}

	
- (void) setAddress: (NSString *)anAddress
{
	[address setAddress: anAddress];
}

	
- (void) setCity: (NSString *)aCity;
{
	[address setCity: aCity];
}

	
- (void) setState: (NSString *)aState
{
	[address setState: aState];
}


- (void) setZip: (NSString *)aZip
{
	[address setZip: aZip];
}


@end
